unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Ev, StdCtrls, ExtCtrls, Spin;

type
  TMainForm = class(TForm)
    Evaluator: TKEvaluator;
    panTop: TPanel;
    edExpression: TEdit;
    panBottom: TPanel;
    panLeft: TPanel;
    panClient: TPanel;
    edResult: TEdit;
    panLeftLeft: TPanel;
    panNumbers: TPanel;
    btn1: TButton;
    btn2: TButton;
    btn3: TButton;
    btn4: TButton;
    btn6: TButton;
    btn5: TButton;
    btn7: TButton;
    btn8: TButton;
    btn0: TButton;
    btn9: TButton;
    panSymbols: TPanel;
    btnOBracket: TButton;
    btnCBracket: TButton;
    panOperators: TPanel;
    panOpTop: TPanel;
    btnPlus: TButton;
    btnMinus: TButton;
    btnMult: TButton;
    btnDiv: TButton;
    btnLT: TButton;
    btnGT: TButton;
    btnDIF: TButton;
    btnLTEQ: TButton;
    btnGTEQ: TButton;
    btnAND: TButton;
    btnOR: TButton;
    btnNOT: TButton;
    btnXOR: TButton;
    btnIN: TButton;
    btnLIKE: TButton;
    btnBETWEEN: TButton;
    btnX: TButton;
    btnY: TButton;
    btnZ: TButton;
    panEQ: TPanel;
    btnEQ: TButton;
    sedX: TSpinEdit;
    sedY: TSpinEdit;
    sedZ: TSpinEdit;
    lblX: TLabel;
    lblY: TLabel;
    lblZ: TLabel;
    panCalculate: TPanel;
    btnCalculate: TButton;
    btnStr: TButton;
    btnOB: TButton;
    btnCB: TButton;
    btn_: TButton;
    btnPecent: TButton;
    panBack: TPanel;
    btnBackSpace: TButton;
    btnSave: TButton;
    btnLoad: TButton;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    procedure btnCalculateClick(Sender: TObject);
    procedure ButtonClick(Sender: TObject);
    procedure btnBackSpaceClick(Sender: TObject);
    procedure EvaluatorGetParam(const AName: String; var AValue: Variant);
    procedure btnSaveClick(Sender: TObject);
    procedure btnLoadClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.btnCalculateClick(Sender: TObject);
begin
  Evaluator.Text := edExpression.Text;
  Evaluator.Evaluate;
  edResult.Text := Evaluator.Result.AsString;
end;

procedure TMainForm.ButtonClick(Sender: TObject);
begin
  if Sender is TButton then
    edExpression.Text := edExpression.Text + TButton(Sender).Caption
end;

procedure TMainForm.btnBackSpaceClick(Sender: TObject);
begin
  edExpression.Text := Copy(edExpression.Text, 1, Length(edExpression.Text)-1);
end;

procedure TMainForm.EvaluatorGetParam(const AName: String;
  var AValue: Variant);
begin
  if AName = 'X' then
    AValue := sedX.Value;

  if AName = 'Y' then
    AValue := sedY.Value;

  if AName = 'Z' then
    AValue := sedZ.Value;
end;

procedure TMainForm.btnSaveClick(Sender: TObject);
begin
  if SaveDialog.Execute then
  begin
    Evaluator.Text := edExpression.Text;
    Evaluator.SaveToFile(SaveDialog.FileName);
  end;
end;

procedure TMainForm.btnLoadClick(Sender: TObject);
begin
  if OpenDialog.Execute then
  begin
    Evaluator.LoadFromFile(OpenDialog.FileName);
    edExpression.Text := Evaluator.Text;
  end;
end;

end.
